/*	$Kolabore: cache.h,v 1.9 2007/02/09 20:58:49 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __CACHE_H__
#define __CACHE_H__

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#include "compat/typesetup.h"

extern "C" {
#ifdef HAVE_GOOD_STDINT_H
#  include <stdint.h>
#endif
}

#include <string>
#include <vector>

#include "util.h"

using namespace std;

struct userdb_cache {
	uint32_t	add_time;
	uint32_t	uid;
	string		user;
};

class XSI_UserCache : private XSI_Util {
public:
	XSI_UserCache(bool /* no lookups */, uint32_t timeout_secs = 1800);

	void		reset(void);
	string		getUsername(uint32_t /* UID */);
	uint32_t	getUID(const char * /* Username */);

	unsigned long	getHits(void);
	unsigned long	getMisses(void);
	unsigned long	getFailures(void);
	unsigned long	getTimeouts(void);

private:
	vector<struct userdb_cache> cache;
	unsigned long	hits, misses, failures, timeouts;
	bool		no_lookups;
	uint32_t	timeout;
};

#endif /* __CACHE_H__ */
