/*	$Kolabore: cfg.h,v 1.24 2007/02/09 13:21:57 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __CFG_H__
#define __CFG_H__

#include <list>
#include <string>
#include <vector>

#include "util.h"

#define DEFAULT_PORT	"11110"

using namespace std;

class Config : private XSI_Util {
public:
	Config(int, char **);
	~Config(void);

	void			usage(void);
	void			usageHelp(void);

	bool			oneClientMode(void);
	bool			compressXml(void);
	bool			dontDetach(void);
	bool			formatOutput(void);
	bool			noNames(void);
	bool			oneShot(void);
	bool			showRaid(void);
	bool			showPacketFilter(void);
	bool			userRequestsPrivdrop(void);
	int			getUpdateInterval(void);
	const char *		getUpdateIntervalString(void);
	struct addrinfo *	getListenAddr(void);
	list<string>		getRaidControllers(void);
	list<string>		getXSIOptionsList(void);
	const char *		getChrootDir(void);
	const char *		getPrivdropUser(void);
	const char *		getPrivdropGroup(void);

private:
	int			update_interval;
	bool			compress_xml;
	bool			dont_detach;
	bool			format_output;
	bool			no_names;
	bool			one_client_mode;
	bool			one_shot;
	bool			show_pf;
	bool			show_raid;
	bool			GFlag, UFlag;
	struct addrinfo        *listen_addr;
	string			chrootDir, unprivUser, unprivGroup;
	list<string>		raid_controllers;
	list<string>		xsi_options;
};

#endif /* __CFG_H__ */
