/*	$Kolabore: common.h,v 1.16 2007/01/06 12:09:52 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * XSICommon:
 * Class for information/stats gathering using methods that are OS/platform-
 * independent.
 */

#ifndef __COMMON_H__
#define __COMMON_H__

#include "xmlsysinfo.h"
#include "pf.h"
#include "ipf.h"
#include "netfilter.h"

using namespace std;

class XSICommon : public XSIBase {
public:
	XSICommon(void);
	virtual ~XSICommon(void);

	virtual int	tryOpenPrivilegedDevices(void);
	virtual int	initializePacketfilters(void);

protected:
	virtual void	updatePacketfilterStats(void);
	virtual void	collectCommonInfo(void);
	virtual void	updateCommonStats(void);

	virtual void	collectSysInfo(void);
	virtual void	updateStats(void);

private:
	PF		pf;
	IPF		ipfilter;
	Netfilter	netfilter;
};

#endif /* __COMMON_H__ */
