/*	$Kolabore: netfilter.cpp,v 1.8 2007/02/09 13:06:06 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * netfilter.cpp:
 * Gather statistics from the Linux packet filter "netfilter".
 * THIS IS JUST A STUB AND DOES NOT DO ANYTHING, YET!
 */

#include "log.h"

extern "C" {
#include <sys/types.h>
#include <sys/socket.h>

#ifdef HAVE_NETFILTER
#  include <linux/netlink.h>
#  include <linux/netfilter/nfnetlink.h>
#  include <linux/netfilter/nfnetlink_conntrack.h>
#endif
}

#include <iostream>

#include "netfilter.h"

using namespace std;

Netfilter::Netfilter(void)
{
	initialized = false;
}

Netfilter::~Netfilter(void)
{
	// empty
}

/*
 * Initialize the Netfilter class and return 1 on success, 0 on failure.
 */
int
Netfilter::init(void)
{
#ifdef HAVE_NETFILTER
	{
		cerr << "Error: Sorry, Netfilter support is only prepared - it "
			"is not implemented, yet." << endl;
		return (0);
	}

	initialized = true;
	return (1);
#else
	return (0);
#endif /* HAVE_NETFILTER */
}

void
Netfilter::updateStats(XSI_PFilter &packetFilter)
{
#ifdef HAVE_NETFILTER
	if (!initialized)
		return;

	packetFilter.setPFilterType(PFILTER_NETFILTER);
	packetFilter.setAvailable(true);
#endif
}
