/*	$Kolabore: network.h,v 1.8 2007/01/03 12:19:33 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * network.h
 * Networking related statistics and information
 */

#ifndef __NETWORK_H__
#define __NETWORK_H__

#include "netifstat.h"
#include "packetfilter.h"
#include "util.h"

using namespace std;

enum route_addr_family {
	XSI_RTAF_IPV4,
	XSI_RTAF_IPV6
};

struct default_route {
	string			gateway;
	enum route_addr_family	family;
};

class XSI_Network : private XSI_Util {
public:
	void			setNetIfStats(vector<XSI_NetIfStat>);
	void			setDefaultRoutes(vector<struct default_route>);

	const char *		getHostName(void);
	vector<XSI_NetIfStat>   getNetIfStats(void);
	vector<struct default_route> getDefaultRoutes(void);

private:
	string			hostname;
	vector<XSI_NetIfStat>	net_stats;
	vector<struct default_route> default_routes;
};

#endif /* __NETWORK_H__ */
