/*	$Kolabore: openbsd.h,v 1.32 2007/01/05 11:53:08 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __OPENBSD_H__
#define __OPENBSD_H__

#include "common.h"

using namespace std;

struct openbsd_private;

class XSI : public XSICommon {
public:
	XSI(void);
	~XSI(void);

	int		tryOpenPrivilegedDevices(void);

private:
	void		collectSysInfo(void);
	void		updateStats(void);

	void		openbsdInit(void);

	void		readSystemInfo(void);
	void		readSystemNumCPUs(void);
	void		readSystemOSInfo(void);

	void		updateCPUFreq(void);
	void		updateCPUStats(void);
	void		updateVMStats(void);
	void		updateFSStats(void);
	void		updateDiskStats(void);
	void		updateOSUptime(void);
	void		updateLoadAvg(void);
	void		updateProcInfo(void);
	void		updateInterrupts(void);
	void		updateSensors(void);
	void		updateNetStats(void);
	void		updateBioRaidInfo(void);

	void		getNetLLAddr(XSI_NetIfStat &, struct sockaddr_dl *);
	void		getNetIfInfo(XSI_NetIfStat &, struct ifaddrs *,
				     struct sockaddr_dl *);
	void		getNetIfmediaInfo(XSI_NetIfStat &);
	void		getNetIfAddrs(XSI_NetIfStat &, struct ifaddrs *, string);
	void		getDefaultRoutes(void);

	string		getSysctlString(int, int, int, unsigned int,
					bool, const char *);
	string		getMediaWordString(int, int);

	struct openbsd_private *priv;
	int		num_cpu;
	int64_t       **last_cp_time, **cur_cp_time;
	int		bio_fd;
};

#endif /* __OPENBSD_H__ */
