/*	$Kolabore: server.h,v 1.20 2007/02/09 13:01:39 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __SERVER_H__
#define __SERVER_H__

#include "cfg.h"

#define MAX_POLLFDS	20

using namespace std;

struct client {
	int			fd;
	struct sockaddr_storage c_addr;
	socklen_t		c_addr_len;
};

class Server {
public:
	Server(Config *);
	~Server(void);

	vector<struct client>	poll(void);
	vector<string>		getListenAddrStrings(void);
	string			getListenServiceString(void);

private:
	void			listen(void);

	Config		       *cfg;
	struct pollfd		pfd[MAX_POLLFDS];
	int			addr_count;
	bool			may_talk;
	vector<string>		listenAddrs;
	string			listenService;
};

#endif /* __SERVER_H__ */
