/*	$Kolabore: solaris.h,v 1.19 2007/01/05 12:09:05 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __SOLARIS_H__
#define __SOLARIS_H__

#include "common.h"

using namespace std;

struct solaris_private;

class XSI : public XSICommon {
public:
	XSI(void);
	~XSI(void);

private:
	void		collectSysInfo(void);
	void		updateStats(void);

	void		solarisInit(void);
	void		updateKstat(void);

	void		readSysinfo(void);
	void		readOSInfo(void);

	void		updateCPUFreq(void);
	void		updateCPUStats(void);
	void		updateVMStats(void);
	void		updateFSStats(void);
	void		updateDiskStats(void);
	void		updateOSUptime(void);
	void		updateLoadAvg(void);
	void		updateProcInfo(void);
	void		updateInterrupts(void);
	void		updateSensors(void);
	void		updateNetStats(void);

	void		setLinkStatus(XSI_NetIfStat &, const char *, int,
				      const char *);
	void		setMediaString(XSI_NetIfStat &, const char *, int,
				       const char *);

	void		getDefaultRoutes(void);

	string		getSysinfoString(int);
	long		getSysconfValue(int);
	int64_t 	getNamedKstatValue(const char *, int, const char *,
					   const char *,
					   bool *must_exist = NULL);
	uint64_t	getNamedKstatUValue(const char *, int, const char *,
					    const char *,
					    bool *must_exist = NULL);
	string		getNamedKstatString(const char *, int, const char *,
					    const char *,
					    bool *must_exist = NULL);
	string		getNamedKstatCharString(const char *, int, const char *,
						const char *,
						bool *must_exist = NULL);

	int		num_cpu;
	uint64_t      **cur_cp_time, **last_cp_time;
	struct solaris_private *priv;
};

#endif /* __SOLARIS_H__ */
