/*	$Kolabore: timekeeper.h,v 1.11 2007/01/03 12:19:33 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * timekeeper.h
 * Singleton timekeeping class
 */

#ifndef __TIMEKEEPER_H__
#define __TIMEKEEPER_H__

extern "C" {
#include <sys/time.h>
}

#include "xmlsysinfo.h"
#include "util.h"

using namespace std;

class XSI_TimeKeeper : private XSI_Util {
public:
	static XSI_TimeKeeper  *get(void);
	bool			haveTimeDelta(void);
	double			timeDelta(void);
	const char *		updateTimestampString(void);
	uint32_t		updateTimestampInt(void);

	friend void XSIBase::updateTimeKeeper(void);

private:
	XSI_TimeKeeper(void);

	void		triggerUpdate(void);

	struct timeval	update_time, last_update_time;
	double		update_time_delta, timestamp;
	bool		have_time_delta;
};

#endif /* __TIMEKEEPER_H__ */
