/*	$Kolabore: fuzzer.h,v 1.14 2007/01/10 19:10:20 maxx Exp $	*/
/*
 * Copyright (c) 2006, 2007 Moritz Grimm <gtgbr@gmx.net>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

#ifndef __FUZZER_H__
#define __FUZZER_H__

#include "common.h"

#define FUZZ_PRINTABLE	0x01
#define FUZZ_7BITPRINT	0x02
#define FUZZ_NOSPACE	0x04
#define FUZZ_DIGITSONLY	0x08
#define FUZZ_HEXDIGITS	0x10

#define FUZZ_NASTY	0x00
#define FUZZ_NICE 	FUZZ_7BITPRINT

#define FUZZ_DEFAULT	FUZZ_NASTY

using namespace std;

class XSI : public XSICommon {
public:
	XSI(void);
	~XSI(void);

	int		tryOpenPrivilegedDevices(void);
	int		initializePacketfilters(void);
	void		updatePacketfilterStats(void);
	void		collectCommonInfo(void);
	void		updateCommonStats(void);

private:
	void		collectSysInfo(void);
	void		updateStats(void);

	void		setSystemInfo(void);
	void		setProcInfo(void);
	void		setSensorInfo(void);
	void		setStorageInfo(void);
	void		setRAIDInfo(void);
	void		setNetworkInfo(void);
	void		setPacketFilterInfo(void);

	uint16_t	xsi_random(void);
	int32_t 	getRandomInt32(bool nonnegative = false);
	int64_t 	getRandomInt64(bool nonnegative = false);
	double		getRandomPercent(void);
	double		getRandomDecimal(void);
	string		getRandomString(unsigned int min_len = 0,
					unsigned int max_len = 1024,
					int fuzz = FUZZ_DEFAULT);
	bool		getRandomBool(void);

	int		num_cpu;
};

#endif /* __FUZZER_H__ */
